class CommonService{

    private ISpecializedService  iSepecializedService;
    private SpecializedServiceFactory specializedServiceFactory = new SpecializedServiceFactory();

    private String protocol;
        
    public CommonService(String aString){
        //common logic/service
        if(aString.startsWith("http:"))
            protocol = "http";
        else if(aString.startsWith("mailto:"))
                protocol = "mailto";
        else
            throw new IllegalArgumentException();
        iSepecializedService = specializedServiceFactory.createService(protocol,aString);
    }
}
