class SpecializedServiceFactory{

    public ISpecializedService createService(String protocol,String aString){
        if(protocol.equals("http"))
            return new HttpService(aString);
        else if(protocol.equals("mailto"))
            return new MailtoService(aString);
        else
            throw new IllegalArgumentException();
    }
}

